//+--------------------------------------------------+
//|PipMaker v5 Neo Last Update 06-27-2007 01:05am    |
//|This is my Version based on the mentioned version.|
//|                                                  |
//|About Enhanced Version (08-15-2007, by parisienne)| 
//|This  Verions has some enhancements for better    | 
//|control                                           |
//|EA stops trading if a cetain amount of money      |
//|has been earned.                                  |
//|Can pasue Trading at NewsTime.                    |
//|Can quit Trading at a certain time.               |
//|Uses a different logic to determine trading       |
//|direction.                                        |
//|Doesn't close trades before CloseDelay time has   |
//|passed.                                           |
//|Finds Lot precision automatically.                |
//+--------------------------------------------------+

//+--------------------------------------------------+
//| How To Use:                                      |
//| Daily Charts                                     |
//| GBPUSD --> TradeLong=true                        | 
//| EURUSD --> TradeShort=true                       |
//| Or vice versa                                    | 
//| Set a Session Target: 500 for a 5000 account is  | 
//| enough. One of the EA's will trade and hopefully |
//| earn the target amount                           | 
//+--------------------------------------------------+
#include <stdlib.mqh>
#include <stderror.mqh>

#define  NL    "\n"

// Regular variables
extern bool    TradeShort              = true;
extern bool    TradeLong               = false;
extern bool    UseDPO                  = true; // Trades long if 30Min-LWMA is above daily open and short if below (idea from OnlyPivot thread)
extern bool    UseSniper               = true; // Trades long if above 0, opposite for short
extern double  LotSize                 = 0.1;
extern double  LotIncrement            = 0.1;
//extern bool    Multiplier            = true;
extern double     Multiplier              = 0;
extern int     ProfitTarget            = 95;
//extern bool    OpenOnTick            = false;
extern int     OpenOnTick              = 1;
extern int     Spacing                 = 15;
extern int     TrendSpacing            = 5;
extern double  CounterTrendMultiplier  = 2;
extern int     CloseDelay              = 91;
extern bool    CeaseTrading            = false;
extern string  PasueTrading            ="Pause Trading at Timeinterval";
extern int     StartTime               = 0; //Example: Trading pause starts at day 15 hour 14, minute 30 (server time)--> input= 151430
extern int     EndTime                 = 0; //Example: Trading pause ends at day 15 hour 15, minute 10 (server time)--> input= 151510
extern string  QuitTrading             = "Quit Trading at Time";
extern int     endDayHourMinute        = 0; //Example: Quit trading on day 17 hour 21 minute 59 (server time)-->input=172159
extern bool    RightSideLabel          = true;
extern int     SessionTarget           = 500; //Trading will be stopped if this amount has been earned in this session
extern int     MaximumBuyOrders        =5;
extern int     MaximumSellOrders       =5;
extern double  ControlAcc              =90; //In Percentage  
// Internal settings
int            Step           = 1;
int            Error          = 0;
int            Order          = 0;
int            Slippage       = 0;
int            Reference      = 0;
string         TradeComment;
double         TickPrice      = 0;

int            MaxBuys        = 0;
int            MaxSells       = 0;

bool           Auditing       = false;
string         Filename;
double         initialBalance;
int            lotPrecision;
int            StopLoss=100;

int init()
{
   if (Symbol() == "AUDCADm" || Symbol() == "AUDCAD") Reference = 801001;
   if (Symbol() == "AUDJPYm" || Symbol() == "AUDJPY") Reference = 801002;
   if (Symbol() == "AUDNZDm" || Symbol() == "AUDNZD") Reference = 801003;
   if (Symbol() == "AUDUSDm" || Symbol() == "AUDUSD") Reference = 801004;
   if (Symbol() == "CHFJPYm" || Symbol() == "CHFJPY") Reference = 801005;
   if (Symbol() == "EURAUDm" || Symbol() == "EURAUD") Reference = 801006;
   if (Symbol() == "EURCADm" || Symbol() == "EURCAD") Reference = 801007;
   if (Symbol() == "EURCHFm" || Symbol() == "EURCHF") Reference = 801008;
   if (Symbol() == "EURGBPm" || Symbol() == "EURGBP") Reference = 801009;
   if (Symbol() == "EURJPYm" || Symbol() == "EURJPY") Reference = 801010;
   if (Symbol() == "EURUSDm" || Symbol() == "EURUSD") Reference = 801011;
   if (Symbol() == "GBPCHFm" || Symbol() == "GBPCHF") Reference = 801012;
   if (Symbol() == "GBPJPYm" || Symbol() == "GBPJPY") Reference = 801013;
   if (Symbol() == "GBPUSDm" || Symbol() == "GBPUSD") Reference = 801014;
   if (Symbol() == "NZDJPYm" || Symbol() == "NZDJPY") Reference = 801015;
   if (Symbol() == "NZDUSDm" || Symbol() == "NZDUSD") Reference = 801016;
   if (Symbol() == "USDCHFm" || Symbol() == "USDCHF") Reference = 801017;
   if (Symbol() == "USDJPYm" || Symbol() == "USDJPY") Reference = 801018;
   if (Symbol() == "USDCADm" || Symbol() == "USDCAD") Reference = 801019;
   if (Reference == 0) Reference = 801999;
   initialBalance= AccountBalance();   
   TradeComment  = StringConcatenate(Symbol()," ",Period()," ","PM"," S_ID: ",TimeLocal());      
   Filename = StringConcatenate("PipMaker_v5_",Symbol(),"_",Period(),"_M",".txt");
   CalculateLotPrecision();
   return(0);
}

int deinit()
{
   if(ObjectFind("MidPoint")==0){
      ObjectDelete("MidPoint");      
   }
   if(ObjectFind("MarginPercent")==0){
      ObjectDelete("MarginPercent");
   }
   if(ObjectFind("LowMarginPercent")==0){
      ObjectDelete("LowMarginPercent");
   }   
   Comment("");
   return(0);
}

void CalculateLotPrecision(){
   double lotstep=MarketInfo(Symbol(),MODE_LOTSTEP);
   if(lotstep==1) lotPrecision=0;
   if(lotstep==0.1) lotPrecision=1;
   if(lotstep==0.01) lotPrecision=2;
   if(lotstep==0.001) lotPrecision=3;
}

void CloseBuysInProfit()
{
   double BuyProfit; 

   RefreshRates();
   
   for (Order = OrdersTotal() - 1; Order >= 0; Order--)
   {
      if (OrderSelect(Order, SELECT_BY_POS, MODE_TRADES))
      {
         if (OrderSymbol() == Symbol() && OrderMagicNumber() == Reference && OrderType() == OP_BUY)
         {
            BuyProfit = OrderProfit() + OrderSwap() + OrderCommission();
            if ((TimeCurrent()-OrderOpenTime()>=CloseDelay) && BuyProfit > 0) OrderClose(OrderTicket(), OrderLots(), OrderClosePrice(), Slippage, Green);//IsTesting() ||
 
            Error = GetLastError();
            if (Error != 0) Write("Error closing BUY order " + OrderTicket() + ": " + ErrorDescription(Error) + " (A" + Error + ")  Lots:" + OrderLots() + "  Bid:" + MarketInfo(OrderSymbol(), MODE_BID));
         }
      }
   }
   return;
}

void CloseSellsInProfit()
{
   double SellProfit, LastSellTime;

   RefreshRates();
   
   for (Order = OrdersTotal() - 1; Order >= 0; Order--)
   {
      if (OrderSelect(Order, SELECT_BY_POS, MODE_TRADES))
      {
         if (OrderSymbol() == Symbol() && OrderMagicNumber() == Reference && OrderType() == OP_SELL)
         {
            SellProfit = OrderProfit() + OrderSwap() + OrderCommission();
            if (TimeCurrent()-OrderOpenTime()>=CloseDelay && SellProfit > 0) OrderClose(OrderTicket(), OrderLots(), OrderClosePrice(), Slippage, Red);

            Error = GetLastError();
            if (Error != 0) Write("Error closing SELL order " + OrderTicket() + ": " + ErrorDescription(Error) + " (B" + Error + ")  Lots:" + OrderLots() + "  Ask:" + MarketInfo(OrderSymbol(), MODE_ASK));
         }
      }
   }
   return;
}

void PlaceBuyOrder()
{
   double BuyOrders, Lots;
   double LowestBuy = 1000, HighestBuy;

   TickPrice = 0;

   RefreshRates();
   
   for (Order = OrdersTotal() - 1; Order >= 0; Order--)
   {
      if (OrderSelect(Order, SELECT_BY_POS, MODE_TRADES))
      {
         if (OrderSymbol() == Symbol() && OrderMagicNumber() == Reference && OrderType() == OP_BUY)
         {
            if (OrderOpenPrice() < LowestBuy) LowestBuy = OrderOpenPrice();
            if (OrderOpenPrice() > HighestBuy) HighestBuy = OrderOpenPrice();
            BuyOrders++;
         }
      }
   }

   if (Ask >= HighestBuy + (TrendSpacing * Point))
   {
      if (Multiplier == 1)
         Lots = NormalizeDouble(LotSize * MathPow(LotIncrement, BuyOrders), lotPrecision);
      else
         Lots = NormalizeDouble(LotSize + (LotIncrement * BuyOrders), lotPrecision);
   }

   if (Ask <= LowestBuy - (Spacing * Point))
   {
      if (Multiplier == 1)
         Lots = NormalizeDouble(LotSize * CounterTrendMultiplier * MathPow(LotIncrement, BuyOrders), lotPrecision);
      else
         Lots = NormalizeDouble((LotSize * CounterTrendMultiplier) + (LotIncrement * BuyOrders), lotPrecision);
   }

   if(BuyOrders==0)
   {
      Lots = NormalizeDouble(LotSize, lotPrecision);
   }

   if (Lots == 0)
   {
      if (Multiplier == 1)
         Lots = NormalizeDouble(LotSize, lotPrecision);
      else
         Lots = NormalizeDouble(LotSize, lotPrecision);
   }
   
   if(IsTradeAllowed()==true  && (BuyOrders < MaximumBuyOrders))
   {
      OrderSend(Symbol(), OP_BUY, Lots, Ask, Slippage, 0, 0, TradeComment, Reference, Green);
   }

   Error = GetLastError();
   if (Error != 0)
      Write("Error opening BUY order: " + ErrorDescription(Error) + " (C" + Error + ")  Ask:" + Ask + "  Slippage:" + Slippage);
   else
   {
      TickPrice = Close[0];
   }

}

void PlaceSellOrder()
{
   double SellOrders, Lots;
   double HighestSell, LowestSell = 1000;

   TickPrice = 0;

   RefreshRates();
   
   for (Order = OrdersTotal() - 1; Order >= 0; Order--)
   {
      if (OrderSelect(Order, SELECT_BY_POS, MODE_TRADES))
      {
         if (OrderSymbol() == Symbol() && OrderMagicNumber() == Reference && OrderType() == OP_SELL)
         {
            if (OrderOpenPrice() > HighestSell) HighestSell = OrderOpenPrice();
            if (OrderOpenPrice() < LowestSell) LowestSell = OrderOpenPrice();
            SellOrders++;
         }
      }
   }

   if (Bid <= LowestSell - (TrendSpacing * Point))
   {
//         if (Multiplier)
      if (Multiplier == 1)
         Lots = NormalizeDouble(LotSize * MathPow(LotIncrement, SellOrders), lotPrecision);
      else
         Lots = NormalizeDouble(LotSize + (LotIncrement * SellOrders), lotPrecision);
   }
   
   if (Bid >= HighestSell + (Spacing * Point))
   {
//         if (Multiplier)
      if (Multiplier == 1)
         Lots = NormalizeDouble(LotSize * CounterTrendMultiplier * MathPow(LotIncrement, SellOrders), lotPrecision);
      else
         Lots = NormalizeDouble((LotSize * CounterTrendMultiplier) + (LotIncrement * SellOrders), lotPrecision);
   }

   if(SellOrders==0)
   {
      Lots = NormalizeDouble(LotSize, lotPrecision);
   }

   if (Lots == 0)
   {
//         if (Multiplier) 
      if (Multiplier == 1)
         Lots = NormalizeDouble(LotSize, lotPrecision);
      else
         Lots = NormalizeDouble(LotSize, lotPrecision);
   }
   
   if(IsTradeAllowed()==true && (SellOrders < MaximumSellOrders))
   {   
      OrderSend(Symbol(), OP_SELL, Lots, Bid, Slippage, 0, 0, TradeComment, Reference, Red);
   }
   
   Error = GetLastError();
   if (Error != 0)
      Write("Error opening SELL order: " + ErrorDescription(Error) + " (D" + Error + ")  Bid:" + Bid + "  Slippage:" + Slippage);
   else
   {
      TickPrice = Close[0];
   }
}


int start()
{
   double         MarginPercent;
   static double  LowMarginPercent = 10000000, LowEquity = 10000000;
   double         BuyPipTarget, SellPipTarget;
   int            SellOrders, BuyOrders;
   double         BuyPips, SellPips, BuyLots, SellLots;
   double         LowestBuy = 999, HighestBuy = 0.0001, LowestSell = 999, HighestSell = 0.0001, HighPoint, MidPoint, LowPoint;
   double         Profit = 0, BuyProfit = 0, SellProfit = 0, PosBuyProfit = 0, PosSellProfit = 0;
   int            HighestBuyTicket, LowestBuyTicket, HighestSellTicket, LowestSellTicket;
   double         HighestBuyProfit, LowestBuyProfit, HighestSellProfit, LowestSellProfit;
   bool           SELLme = false;
   bool           BUYme = false;
   double         Margin = MarketInfo(Symbol(), MODE_MARGINREQUIRED);
   string         Message;

   PercentageAccount();
   
   for (Order = OrdersTotal() - 1; Order >= 0; Order--)
   {
      if (OrderSelect(Order, SELECT_BY_POS, MODE_TRADES))
      {
         if (OrderSymbol() == Symbol() && OrderMagicNumber() == Reference)
         {
            
            Profit = OrderProfit() + OrderSwap() + OrderCommission();
            
            if (OrderType() == OP_BUY)
            {
               if (OrderOpenPrice() >= HighestBuy)
               {
                  HighestBuy = OrderOpenPrice();
                  HighestBuyTicket = OrderTicket();
                  HighestBuyProfit = Profit;
               }

               if (OrderOpenPrice() <= LowestBuy)
               {
                  LowestBuy = OrderOpenPrice();
                  LowestBuyTicket = OrderTicket();
                  LowestBuyProfit = Profit;
               }

               BuyOrders++;
               if (BuyOrders > MaxBuys) MaxBuys = BuyOrders;
               BuyLots += OrderLots();

               BuyProfit += Profit;
               if (Profit > 0) PosBuyProfit += Profit;
            }

            if (OrderType() == OP_SELL)
            {
               if (OrderOpenPrice() <= LowestSell)
               {
                  LowestSell = OrderOpenPrice();
                  LowestSellTicket = OrderTicket();
                  LowestSellProfit = Profit;
               }

               if (OrderOpenPrice() >= HighestSell)
               {
                  HighestSell = OrderOpenPrice();
                  HighestSellTicket = OrderTicket();
                  HighestSellProfit = Profit;
               }

               SellOrders++;
               if (SellOrders > MaxSells) MaxSells = SellOrders;
               SellLots += OrderLots();

               SellProfit += Profit;
               if (Profit > 0) PosSellProfit += Profit;
            }
         }
      }
   }

      BuyPipTarget = ProfitTarget;
      SellPipTarget = ProfitTarget;

   if (HighestBuy >= HighestSell)
      HighPoint = HighestBuy;
   else
      HighPoint = HighestSell;

   if (LowestBuy <= LowestSell)
      LowPoint = LowestBuy;
   else
      LowPoint = LowestSell;

   MidPoint = (HighPoint + LowPoint) / 2;

//   if ((SellOrders > 1 && BuyOrders > 0) || (SellOrders > 0 && BuyOrders > 1)) MidPoint = (HighPoint + LowPoint) / 2;

   RefreshRates();

   if (Ask > MidPoint)
   {
      if (PosBuyProfit + LowestSellProfit >= ProfitTarget && LowestSell < LowestBuy)
      {
         OrderSelect(LowestSellTicket, SELECT_BY_TICKET);

         Error = GetLastError();
         if (Error != 0) Write("Error accessing SELL order " + LowestSellTicket + ": " + ErrorDescription(Error) + " (E" + Error + ")");
                      
         if(TimeCurrent()-OrderOpenTime()>=CloseDelay && IsTradeAllowed()==true)
         {
            OrderClose(OrderTicket(), OrderLots(), OrderClosePrice(), Slippage, Green);
         }
         
         Error = GetLastError();
         if (Error != 0) Write("Error closing SELL order " + OrderTicket() + ": " + ErrorDescription(Error) + " (F" + Error + ")  Lots:" + OrderLots() + "  Ask:" + MarketInfo(OrderSymbol(), MODE_ASK));

         CloseBuysInProfit();

         LowestBuy = 1000;
         HighestBuy = 0;
         LowestSell = 1000;
         LowestSellTicket = 0;
      }
      else if (PosSellProfit + LowestSellProfit >= ProfitTarget && LowestSell < LowestBuy)
      {
         OrderSelect(LowestSellTicket, SELECT_BY_TICKET);

         Error = GetLastError();
         if (Error != 0) Write("Error accessing SELL order " + LowestSellTicket + ": " + ErrorDescription(Error) + " (G" + Error + ")");

         if(TimeCurrent()-OrderOpenTime()>=CloseDelay && IsTradeAllowed()==true)
         {
            OrderClose(OrderTicket(), OrderLots(), OrderClosePrice(), Slippage, Red);
         }
         
         Error = GetLastError();
         if (Error != 0) Write("Error closing SELL order " + OrderTicket() + ": " + ErrorDescription(Error) + " (H" + Error + ")  Lots:" + OrderLots() + "  Ask:" + MarketInfo(OrderSymbol(), MODE_ASK));

         CloseSellsInProfit();

         LowestSell = 1000;
         HighestSell = 0;
         LowestSellTicket = 0;
      }
      else if (PosBuyProfit + LowestBuyProfit >= ProfitTarget && LowestBuy < LowestSell)
      {
         OrderSelect(LowestBuyTicket, SELECT_BY_TICKET);

         Error = GetLastError();
         if (Error != 0) Write("Error accessing BUY order " + LowestBuyTicket + ": " + ErrorDescription(Error) + " (I" + Error + ")");

         if(TimeCurrent()-OrderOpenTime()>=CloseDelay && IsTradeAllowed()==true)
         {
            OrderClose(OrderTicket(), OrderLots(), OrderClosePrice(), Slippage, Green);
         }
         
         Error = GetLastError();
         if (Error != 0) Write("Error closing BUY order " + OrderTicket() + ": " + ErrorDescription(Error) + " (J" + Error + ")  Lots:" + OrderLots() + "  Bid:" + MarketInfo(OrderSymbol(), MODE_BID));

         CloseBuysInProfit();

         LowestBuy = 1000;
         HighestBuy = 0;
         LowestBuyTicket = 0;
      }
      
      else if (PosBuyProfit + HighestBuyProfit >= ProfitTarget)
      {
         OrderSelect(HighestBuyTicket, SELECT_BY_TICKET);

         Error = GetLastError();
         
         if (Error != 0) Write("Error accessing BUY order " + LowestBuyTicket + ": " + ErrorDescription(Error) + " (I" + Error + ")");

         if(TimeCurrent()-OrderOpenTime()>=CloseDelay && IsTradeAllowed())
         {
            OrderClose(OrderTicket(), OrderLots(), OrderClosePrice(), Slippage, Green);
         }
         
         Error = GetLastError();
         if (Error != 0) Write("Error closing BUY order " + OrderTicket() + ": " + ErrorDescription(Error) + " (J" + Error + ")  Lots:" + OrderLots() + "  Bid:" + MarketInfo(OrderSymbol(), MODE_BID));

         CloseBuysInProfit();

         LowestBuy = 1000;
         HighestBuy = 0;
         HighestBuyTicket = 0;
      }
      
      
      else if (PosSellProfit + LowestBuyProfit >= ProfitTarget && LowestBuy < LowestSell)
      {
         OrderSelect(LowestBuyTicket, SELECT_BY_TICKET);

         Error = GetLastError();
         if (Error != 0) Write("Error accessing BUY order " + LowestBuyTicket + ": " + ErrorDescription(Error) + " (K" + Error + ")");

         if(TimeCurrent()-OrderOpenTime()>=CloseDelay && IsTradeAllowed())
         {
            OrderClose(OrderTicket(), OrderLots(), OrderClosePrice(), Slippage, Red);
         }
         
         Error = GetLastError();
         if (Error != 0) Write("Error closing BUY order " + OrderTicket() + ": " + ErrorDescription(Error) + " (L" + Error + ")  Lots:" + OrderLots() + "  Bid:" + MarketInfo(OrderSymbol(), MODE_BID));

         CloseSellsInProfit();

         LowestSell = 1000;
         HighestSell = 0;
         LowestBuy = 1000;
         LowestBuyTicket = 0;
      }
   }
   else if (Bid < MidPoint)
   {
      if (PosBuyProfit + HighestBuyProfit >= ProfitTarget && HighestBuy > HighestSell)
      {
         OrderSelect(HighestBuyTicket, SELECT_BY_TICKET);

         Error = GetLastError();
         if (Error != 0) Write("Error accessing BUY order " + HighestBuyTicket + ": " + ErrorDescription(Error) + " (M" + Error + ")");

         if(TimeCurrent()-OrderOpenTime()>=CloseDelay && IsTradeAllowed())
         {
            OrderClose(OrderTicket(), OrderLots(), OrderClosePrice(), Slippage, Green);
         }
         
         Error = GetLastError();
         if (Error != 0) Write("Error closing BUY order " + OrderTicket() + ": " + ErrorDescription(Error) + " (N" + Error + ")  Lots:" + OrderLots() + "  Bid:" + MarketInfo(OrderSymbol(), MODE_BID));

         CloseBuysInProfit();

         LowestBuy = 1000;
         HighestBuy = 0;
         HighestBuyTicket = 0;
      }
      else if (PosSellProfit + HighestBuyProfit >= ProfitTarget && HighestBuy > HighestSell)
      {
         OrderSelect(HighestBuyTicket, SELECT_BY_TICKET);

         Error = GetLastError();
         if (Error != 0) Write("Error accessing BUY order " + HighestBuyTicket + ": " + ErrorDescription(Error) + " (O" + Error + ")");

         if(TimeCurrent()-OrderOpenTime()>=CloseDelay && IsTradeAllowed()==true)
         {
            OrderClose(OrderTicket(), OrderLots(), OrderClosePrice(), Slippage, Red);
         }

         Error = GetLastError();
         if (Error != 0) Write("Error closing BUY order " + OrderTicket() + ": " + ErrorDescription(Error) + " (P" + Error + ")  Lots:" + OrderLots() + "  Bid:" + MarketInfo(OrderSymbol(), MODE_BID));

         CloseSellsInProfit();

         LowestSell = 1000;
         HighestSell = 0;
         HighestBuy = 0;
         HighestBuyTicket = 0;
      }
      else if (PosBuyProfit + HighestSellProfit >= ProfitTarget && HighestSell > HighestBuy)
      {
         OrderSelect(HighestSellTicket, SELECT_BY_TICKET);

         Error = GetLastError();
         if (Error != 0) Write("Error accessing SELL order " + HighestSellTicket + ": " + ErrorDescription(Error) + " (Q" + Error + ")");

         if(TimeCurrent()-OrderOpenTime()>=CloseDelay && IsTradeAllowed()==true)
         {
            OrderClose(OrderTicket(), OrderLots(), OrderClosePrice(), Slippage, Green);
         }
         
         Error = GetLastError();
         if (Error != 0) Write("Error closing SELL order " + OrderTicket() + ": " + ErrorDescription(Error) + " (R" + Error + ")  Lots:" + OrderLots() + "  Ask:" + MarketInfo(OrderSymbol(), MODE_ASK));

         CloseBuysInProfit();

         LowestBuy = 1000;
         HighestBuy = 0;
         HighestSell = 0;
         HighestSellTicket = 0;
      }
      else if (PosSellProfit + HighestSellProfit >= ProfitTarget && HighestSell > HighestBuy)
      {
         OrderSelect(HighestSellTicket, SELECT_BY_TICKET);

         Error = GetLastError();
         if (Error != 0) Write("Error accessing SELL order " + HighestSellTicket + ": " + ErrorDescription(Error) + " (S" + Error + ")");

         if(TimeCurrent()-OrderOpenTime()>=CloseDelay && IsTradeAllowed()==true)
         {
            OrderClose(OrderTicket(), OrderLots(), OrderClosePrice(), Slippage, Red);
         }
         
         Error = GetLastError();
         if (Error != 0) Write("Error closing SELL order " + OrderTicket() + ": " + ErrorDescription(Error) + " (T" + Error + ")  Lots:" + OrderLots() + "  Ask:" + MarketInfo(OrderSymbol(), MODE_ASK));

         CloseSellsInProfit();

         LowestSell = 1000;
         HighestSell = 0;
         HighestSellTicket = 0;
      }
   }

   RefreshRates();

   // BUY Trade Criteria
   if (HighestBuy > 0 && LowestBuy < 1000)
   {
      if (Ask <= LowestBuy - (Spacing * Point) || Ask >= HighestBuy + (TrendSpacing * Point))
      {
         BUYme = true;
         if (OpenOnTick == 1 && TickPrice > 0 && Close[0] < TickPrice) BUYme = true;
      }
      if (CeaseTrading && BuyOrders == 0) BUYme = false;
      if (SnipersDecision(1)!=1 || Direction(1)!=1 || PauseAtTime(StartTime,EndTime,1)!=1) BUYme = false;//Ask < Trend marketQuality()!=1
      if (BUYme && TradeLong==true) PlaceBuyOrder();
   }

   // SELL Trade Criteria
   if (HighestSell > 0 && LowestSell < 1000)
   {
      if (Bid >= HighestSell + (Spacing * Point) || Bid <= LowestSell - (TrendSpacing * Point))
      {
         SELLme = true;
//          if (OpenOnTick && TickPrice > 0 && Close[0] > TickPrice) TradeAllowed = true;
         if (OpenOnTick == 1 && TickPrice > 0 && Close[0] > TickPrice) SELLme = true;
      }
      if (CeaseTrading && SellOrders == 0) SELLme = false;
      if (SnipersDecision(-1)!=-1 || Direction(-1)!=-1 || PauseAtTime(StartTime,EndTime,-1)!=-1) SELLme = false;//Bid > Trend marketQuality()!=-1
      if (SELLme && TradeShort==true) PlaceSellOrder();
   }

   if(AccountMargin()!=0)
   {
      MarginPercent = MathRound((AccountEquity() / AccountMargin()) * 100);
   }   

   if (LowMarginPercent > MarginPercent) LowMarginPercent = MarginPercent;
   if (AccountEquity() < LowEquity) LowEquity = AccountEquity();

   Message = "                  PipMakerV5aNeo_Enhanced_V1" + NL +
             "                            ProfitTarget           " + DoubleToStr(BuyPipTarget, 2) + NL +
             "                            Buys                    " + BuyOrders + "  Highest: " + MaxBuys + NL +
             "                            BuyLots                " + DoubleToStr(BuyLots, 2) + NL +
             "                            BuyProfit              " + DoubleToStr(BuyProfit, 2) + NL +
             "                            Highest Buy           " + DoubleToStr(HighestBuy, Digits) + " #" + DoubleToStr(HighestBuyTicket, 0) + "  Profit: " + DoubleToStr(HighestBuyProfit, 2) + NL +
             "                            Highest Sell           " + DoubleToStr(HighestSell, Digits) + " #" + DoubleToStr(HighestSellTicket, 0) + "  Profit: " + DoubleToStr(HighestSellProfit, 2) + NL + NL +
             "                            ProfitTarget           " + DoubleToStr(SellPipTarget, 2) + NL +
             "                            Sells                     " + SellOrders + "  Highest: " + MaxSells + NL +
             "                            SellLots                 " + DoubleToStr(SellLots, 2) + NL +
             "                            SellProfit               " + DoubleToStr(SellProfit, 2) + NL +
             "                            Lowest Buy            " + DoubleToStr(LowestBuy, Digits) + " #" + DoubleToStr(LowestBuyTicket, 0) + "  Profit: " + DoubleToStr(LowestBuyProfit, 2) + NL +
             "                            Lowest Sell            " + DoubleToStr(LowestSell, Digits) + " #" + DoubleToStr(LowestSellTicket, 0) + "  Profit: " + DoubleToStr(LowestSellProfit, 2) + NL + NL +
             "                            Balance                " + DoubleToStr(AccountBalance(), 2) + NL +
             "                            Equity                  " + DoubleToStr(AccountEquity(), 2) + "  Lowest: " + DoubleToStr(LowEquity, 2) + NL + NL +
             "                            Margin                  " + DoubleToStr(AccountMargin(), 2) + NL +
             "                            MarginPercent        " + DoubleToStr(MarginPercent, 2) + NL +
             "                            LowMarginPercent  " + DoubleToStr(LowMarginPercent, 2) + NL +
             "                            Current Time is      " +  TimeToStr(TimeCurrent(), TIME_SECONDS);
   Comment(Message);
   
   if (RightSideLabel) 
   {
      string MarPercent = DoubleToStr(MarginPercent, 0);
      string LowMarPercent = DoubleToStr(LowMarginPercent, 0);

      string AcctBalance = DoubleToStr(AccountBalance(), 0);
      ObjectDelete("MarginPercent");

      if (ObjectFind("MarginPercent") != 0)
      {
         ObjectCreate("MarginPercent", OBJ_TEXT, 0, Time[0], Close[0]);
         ObjectSetText("MarginPercent", MarPercent + "%  " + LowMarPercent + "%  $" + AcctBalance, 10, "Arial Black", DodgerBlue);
      }
      else
      {
         ObjectMove("MarginPercent", 0, Time[0], Close[0]);
      }
   }

   if (ObjectFind("MidPoint") != 0)
   {
      ObjectCreate("MidPoint", OBJ_HLINE, 0, Time[0], MidPoint);
      ObjectSet("MidPoint", OBJPROP_COLOR, Gold);
      ObjectSet("MidPoint", OBJPROP_WIDTH, 2);
   }
   else
   {
      ObjectMove("MidPoint", 0, Time[0], MidPoint);
   }   
      
   //QuitTrading(SellOrders);
   getSessionTarget();
   QuitAtTime(endDayHourMinute);
   return(0);
}


void Write(string String)
{
   int Handle;

   if (!Auditing) return;

   Handle = FileOpen(Filename, FILE_READ|FILE_WRITE|FILE_CSV, "/t");
   if (Handle < 1)
   {
      Print("Error opening audit file: Code ", GetLastError());
      return;
   }

   if (!FileSeek(Handle, 0, SEEK_END))
   {
      Print("Error seeking end of audit file: Code ", GetLastError());
      return;
   }

   if (FileWrite(Handle, TimeToStr(CurTime(), TIME_DATE|TIME_SECONDS) + "  " + String) < 1)
   {
      Print("Error writing to audit file: Code ", GetLastError());
      return;
   }

   FileClose(Handle);
}

int Direction(int tradeDirection) //tradeDirection=1: long, tradeDirection=-1: short 
{
   int returnValue;
   
   if(UseDPO==True)
   {
      if(iMA(Symbol(),PERIOD_M30,2,0,MODE_LWMA,PRICE_WEIGHTED,0)>(iOpen(Symbol(),PERIOD_D1,0)+MarketInfo(Symbol(),MODE_SPREAD)*Point)) {returnValue=1;} // Trade Direction Long
	   if(iMA(Symbol(),PERIOD_M30,2,0,MODE_LWMA,PRICE_WEIGHTED,0)<(iOpen(Symbol(),PERIOD_D1,0)-MarketInfo(Symbol(),MODE_SPREAD)*Point)) {returnValue=-1;} // Trade Direction Short 
	}
	else
	{
	  if(tradeDirection==1){returnValue=1;}
	  if(tradeDirection==-1){returnValue=-1;}
	}
	return(returnValue);
}

int SnipersDecision(int tradeDirection)
{
   int returnValue;

   if(UseSniper==true)
   {
      double val=iCustom(NULL, PERIOD_M1,"FX Sniper\'s T3 CCI",120,5,0.618,0,0);
      if(val>0){returnValue=1;}
      if(val<0){returnValue=-1;}
   }
   else
   {
	  if(tradeDirection==1){returnValue=1;}
	  if(tradeDirection==-1){returnValue=-1;}      
   }   
   return(returnValue);         
}

void QuitAtTime(int endDayHour)//input example: close trading tomorrow at 20:59. Today: 14. April, toworrow:15.April. 142059
{
   int t=TimeDay(TimeCurrent())*10000+TimeHour(TimeCurrent())*100+TimeMinute(TimeCurrent());
   if(t>=endDayHour && endDayHour!=0)
   {
      CeaseTrading=true;
      ExitAllTrades(Gold, "Stopped Trading because endtime reached!");
   }
}

int PauseAtTime(int startTime, int endTime, int tradeDirection)
{
   int returnValue;
   if(startTime!=0 && endTime!=0)
   {
      int t=TimeDay(TimeCurrent())*10000+TimeHour(TimeCurrent())*100+TimeMinute(TimeCurrent());
      if(t>=startTime && t<=endTime)
      {
         returnValue=0;
      }
      else
      {
         if(tradeDirection==1){returnValue=1;}
         if(tradeDirection==-1){returnValue=-1;}
      }
   }
   else
   {
      if(tradeDirection==1){returnValue=1;}
      if(tradeDirection==-1){returnValue=-1;}      
   }
   return (returnValue);
}

double SessionProfit()
{
   double profitHistory;
   double profitOpenP;
   double returnValue;
     
   for(int i = OrdersHistoryTotal()-1; i>=0; i--)
   {
      OrderSelect(i,SELECT_BY_POS,MODE_HISTORY);
      if(OrderSymbol()==Symbol() && OrderMagicNumber()==Reference)
      {
         if(OrderComment()==TradeComment)
         {
            profitHistory +=OrderProfit(); 
         }
      }
   }
   
   for(int j=OrdersTotal()-1;j>=0;j--)
   {
      OrderSelect(j,SELECT_BY_POS,MODE_TRADES);
      if(OrderSymbol()==Symbol() && OrderMagicNumber()==Reference)
      {
         if(OrderComment()==TradeComment)
         {
            profitOpenP +=OrderProfit(); 
         }
      }      
   }
   
   returnValue=profitHistory+profitOpenP;   
   return(returnValue);         
}

void getSessionTarget()
{
   if(SessionTarget>0){
      if(SessionProfit()>=SessionTarget)
      {
         CeaseTrading=true;
         ExitAllTrades(Aqua, "Session Target Achieved. YUHUUI!");           
      }
   }   
}

void ExitAllTrades(color Color, string reason){
   bool success;
   for (int cnt = OrdersTotal() - 1; cnt >= 0; cnt --){
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if (OrderSymbol() == Symbol() && OrderMagicNumber() == Reference){
         success=OrderClose(OrderTicket(), OrderLots(), OrderClosePrice(), Slippage, Color);
         if(success==true){
            Print("Closed all positions because ",reason);
         }
      }   
   }
}   

void PercentageAccount()
{
   bool success;
   double Percentage, myEquity, myBalance;
   
   myEquity = AccountEquity();
   myBalance = AccountBalance();
   
   Percentage = (myEquity / myBalance) * 100;
   if (Percentage <= ControlAcc)
   {
    ExitAllTrades(Aqua, "Warning!Floatingloss position may harmfull");  
   }
}    